---
title: 'SyntaxError: missing : after property id'
slug: Web/JavaScript/Reference/Errors/Missing_colon_after_property_id
tags:
  - Error
  - Errors
  - JavaScript
  - SyntaxError
---
<div>{{jsSidebar("Errors")}}</div>

<p>The JavaScript exception "missing : after property id" occurs when objects are created using the <a href="/en-US/docs/Web/JavaScript/Reference/Operators/Object_initializer">object initializer</a> syntax. A colon (<code>:</code>) separates keys and values for the object's properties. Somehow, this colon is missing or misplaced.</p>

<h2 id="Message">Message</h2>

<pre class="syntaxbox">SyntaxError: Expected ':' (Edge)
SyntaxError: missing : after property id (Firefox)
</pre>

<h2 id="Error_type">Error type</h2>

<p>{{jsxref("SyntaxError")}}</p>

<h2 id="What_went_wrong">What went wrong?</h2>

<p>When creating objects with the <a href="/en-US/docs/Web/JavaScript/Reference/Operators/Object_initializer">object initializer</a> syntax, a colon (<code>:</code>) separates keys and values for the object's properties.</p>

<pre class="brush: js">var obj = { propertyKey: 'value' };
</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Colons_vs._equal_signs">Colons vs. equal signs</h3>

<p>This code fails, as the equal sign can't be used this way in this object initializer syntax.</p>

<pre class="brush: js example-bad">var obj = { propertyKey = 'value' };
// SyntaxError: missing : after property id
</pre>

<p>Correct would be to use a colon, or to use square brackets to assign a new property after the object has been created already.</p>

<pre class="brush: js example-good">var obj = { propertyKey: 'value' };

// or alternatively

var obj = { };
obj['propertyKey'] = 'value';
</pre>

<h3 id="Empty_properties">Empty properties</h3>

<p>You can't create empty properties like this:</p>

<pre class="brush: js example-bad">var obj = { propertyKey; };
// SyntaxError: missing : after property id
</pre>

<p>If you need to define a property without a value, you might use {{jsxref("null")}} as a value.</p>

<pre class="brush: js example-good">var obj = { propertyKey: null };</pre>

<h3 id="Computed_properties">Computed properties</h3>

<p>If you create a property key from an expression, you need to use square brackets. Otherwise the property name can't be computed:</p>

<pre class="brush: js example-bad">var obj = { 'b'+'ar': 'foo' };
// SyntaxError: missing : after property id
</pre>

<p>Put the expression in brackets <code>[]</code>:</p>

<pre class="brush: js example-good">var obj = { ['b'+'ar']: 'foo' };</pre>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Operators/Object_initializer">Object initializer</a></li>
</ul>
